=== debian/changelog ===
springlobby (0.139-1) unstable; urgency=low

  * New upstream version.
  * update debian/copyright format version
  * update debian/copyright, add myself for debian/* files

 -- Jan Dittberner <jandd@debian.org>  Sun, 02 Oct 2011 22:54:08 +0200

springlobby (0.135-1) unstable; urgency=low

  * New upstream version.
  * debian/control: add libboost-dev to Build-Depends

 -- Jan Dittberner <jandd@debian.org>  Thu, 04 Aug 2011 15:34:27 +0200
