=== debian/changelog ===
springlobby (0.144-1) unstable; urgency=low

  * New upstream version
  * Bump Standards-Version to 3.9.3 (no changes)
  * update debian/copyright format to 1.0

 -- Jan Dittberner <jandd@debian.org>  Sun, 25 Mar 2012 22:29:18 +0200
