=== debian/control ===
--- 
+++ 
@@ -6,7 +6,7 @@
 Build-Depends: debhelper (>= 7.0.50~), cmake, libwxgtk2.8-dev,
  libopenal-dev, asciidoc, xsltproc, docbook-xsl, libcurl4-gnutls-dev,
  libboost-dev
-Standards-Version: 3.9.2
+Standards-Version: 3.9.3
 Homepage: http://springlobby.info
 Vcs-Browser: http://git.debian.org/?p=pkg-games/springlobby.git;a=summary
 Vcs-Git: git://git.debian.org/pkg-games/springlobby.git
