## springlobby 0.147

=== CMakeLists.txt ===
--- 
+++ 
@@ -165,7 +165,7 @@
 
 IF( OPTION_TORRENT_SYSTEM )
 	IF( NOT WIN32)
-	    SET ( LIBTORRENT_MIN_VERSION 0.13 )
+	    SET ( LIBTORRENT_MIN_VERSION 0.14 )
 	    pkg_check_modules( LIBTORRENT libtorrent-rasterbar>=${LIBTORRENT_MIN_VERSION} )
 	    IF( LIBTORRENT_FOUND )
 		    INCLUDE_DIRECTORIES( ${LIBTORRENT_INCLUDE_DIRS} )
@@ -178,7 +178,7 @@
 	    IF( Boost_FOUND )
 		    link_directories( ${Boost_LIB_DIR} )
 		    INCLUDE_DIRECTORIES( ${Boost_INCLUDE_DIR} )
-		    SET( SL_BOOST_LIBS boost_system-mt )
+		    SET( SL_BOOST_LIBS boost_system )
 	    ELSE()
 		    MESSAGE( FATAL_ERROR "boost library not found! Please install the package or toggle OPTION_TORRENT_SYSTEM to OFF")
 	    ENDIF()
@@ -230,7 +230,10 @@
 	SET(StandAloneSettings ${StandAloneSettings} src/settings++/settings.rc)
 ELSE(WIN32)
 # If we don't build for windows, include some source code checks as pre-build step.
-    ADD_CUSTOM_TARGET(test_susynclib ALL COMMAND tools/test-susynclib.awk src/springunitsynclib.cpp WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
+	FIND_PROGRAM(AWKBIN awk)
+	IF(AWKBIN)
+		ADD_CUSTOM_TARGET(test_susynclib ALL COMMAND ${AWKBIN} -f tools/test-susynclib.awk src/springunitsynclib.cpp WORKING_DIRECTORY ${PROJECT_SOURCE_DIR})
+	ENDIF(AWKBIN)
 ENDIF(WIN32)
 
 #----------------------------------------------------------------------------------------------------
