=== debian/changelog ===
springlobby (0.147-1) unstable; urgency=low

  * New upstream version
  * enable hardening build flags
    - add dpkg-dev (>= 1.16.1~) to Build-Depends
    - bump debian/compat to 9
    - bump debhelper version in Build-Depends to (>= 9.20120417~)
  * debian/rules: move --buildsystem=cmake to the end of dh invocation
  * move rm -f .gitattributes from clean to override_dh_auto_clean to
    fix FTBFS twice in a row

 -- Jan Dittberner <jandd@debian.org>  Tue, 22 May 2012 12:58:08 +0200
