=== debian/control ===
--- 
+++ 
@@ -3,9 +3,9 @@
 Priority: optional
 Maintainer: Debian Games Team <pkg-games-devel@lists.alioth.debian.org>
 Uploaders: Marco Amadori <marco.amadori@gmail.com>, Jan Dittberner <jandd@debian.org>
-Build-Depends: debhelper (>= 7.0.50~), cmake, libwxgtk2.8-dev,
+Build-Depends: debhelper (>= 9.20120417~), cmake, libwxgtk2.8-dev,
  libopenal-dev, asciidoc, xsltproc, docbook-xsl, libcurl4-gnutls-dev,
- libboost-dev
+ libboost-dev, dpkg-dev (>= 1.16.1~)
 Standards-Version: 3.9.3
 Homepage: http://springlobby.info
 Vcs-Browser: http://git.debian.org/?p=pkg-games/springlobby.git;a=summary
