=== debian/rules ===
--- 
+++ 
@@ -1,10 +1,5 @@
 #!/usr/bin/make -f
 # -*- makefile -*-
-# Sample debian/rules that uses debhelper.
-# This file was originally written by Joey Hess and Craig Small.
-# As a special exception, when this file is copied by dh-make into a
-# dh-make output file, you may use that output file without restriction.
-# This special exception was added by Craig Small in version 0.37 of dh-make.
 
 # Uncomment this to turn on verbose mode.
 #export DH_VERBOSE=1
@@ -46,11 +41,9 @@
 override_dh_auto_clean:
 	+dh_auto_clean
 	$(MAKE) -C debian/manpages clean
-
-clean:
 	rm -f .gitattributes
 
 %:
 	# fail to build on architectures other than amd64 and i386
 	dpkg-architecture -eamd64 || dpkg-architecture -ei386 || exit 1
-	+dh --buildsystem=cmake $@
+	+dh $@ --buildsystem=cmake
